package com.gxwebsoft.shop.controller;

import cn.hutool.core.util.StrUtil;
import com.gxwebsoft.common.core.security.JwtUtil;
import com.gxwebsoft.common.core.utils.RequestUtil;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.entity.Order;
import com.gxwebsoft.shop.service.DealerOrderService;
import com.gxwebsoft.shop.entity.DealerOrder;
import com.gxwebsoft.shop.param.DealerOrderParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.OrderGoodsService;
import com.gxwebsoft.shop.service.OrderService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * 分销商订单记录表控制器
 *
 * @author 科技小王子
 * @since 2024-07-28 11:57:41
 */
@Api(tags = "分销商订单记录表管理")
@RestController
@RequestMapping("/api/shop/dealer-order")
public class DealerOrderController extends BaseController {
    @Resource
    private DealerOrderService dealerOrderService;
    @Resource
    private OrderService orderService;
    @Resource
    private OrderGoodsService orderGoodsService;

    @Autowired
    private RequestUtil requestUtil;

    @ApiOperation("分页查询分销商订单记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<DealerOrder>> page(DealerOrderParam param) {
        // 使用关联查询
        return success(dealerOrderService.pageRel(param));
    }

    @ApiOperation("查询全部分销商订单记录表")
    @GetMapping()
    public ApiResult<List<DealerOrder>> list(DealerOrderParam param) {
        // 使用关联查询
        return success(dealerOrderService.listRel(param));
    }

    @GetMapping("/list-for-first")
    public ApiResult<List<DealerOrder>> listForFirst(HttpServletRequest request) {

        // 使用关联查询
        DealerOrderParam param = new DealerOrderParam();
        param.setFirstUserId(getLoginUser().getUserId());
        List<DealerOrder> list = dealerOrderService.listRel(param);
        List<User> userList = new ArrayList<>();
        if (!list.isEmpty()) {
            requestUtil.setTenantId(getTenantId().toString());
            requestUtil.setAccessToken(JwtUtil.getAccessToken(request));
            List<User> userListRes = requestUtil.getUserList(StrUtil.join(",", list.stream().map(DealerOrder::getUserId).toList()));
            if (userListRes != null && !userListRes.isEmpty()) userList = userListRes;
        }
        for (DealerOrder dealerOrder : list) {
            if (!userList.isEmpty()) {
                dealerOrder.setUser(userList.stream().filter(item -> item.getUserId().equals(dealerOrder.getUserId())).findFirst().orElse(null));
            }
            Order order = orderService.getByIdRel(dealerOrder.getOrderId());
            order.setGoodsList(orderGoodsService.listByOrderId(dealerOrder.getOrderId()));
            dealerOrder.setOrder(order);
        }
        return success(list);
    }

    @PreAuthorize("hasAuthority('shop:dealerOrder:list')")
    @ApiOperation("根据id查询分销商订单记录表")
    @GetMapping("/{id}")
    public ApiResult<DealerOrder> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(dealerOrderService.getByIdRel(id));
    }

    @ApiOperation("添加分销商订单记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody DealerOrder dealerOrder) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            dealerOrder.setUserId(loginUser.getUserId());
        }
        if (dealerOrderService.save(dealerOrder)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改分销商订单记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody DealerOrder dealerOrder) {
        if (dealerOrderService.updateById(dealerOrder)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除分销商订单记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (dealerOrderService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加分销商订单记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<DealerOrder> list) {
        if (dealerOrderService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改分销商订单记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<DealerOrder> batchParam) {
        if (batchParam.update(dealerOrderService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除分销商订单记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (dealerOrderService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
